#!/usr/local/bin/perl

use lib "E:/perl/site/lib";
use Tk;

use Time::Local('timelocal');

my $mw = MainWindow->new;

$mw->title("Time");

=cut
$mw->Button( -text => "Bye!", -command => sub { exit } )->pack(
      -side => "bottom" );
=cut


$mw->Button( -text => "Open Me Again", -command => sub { 
              system("e:/perl/bin/perl e:/projects/perltk/tutime.pl") } );


$human = $mw->Entry(
            -textvariable => \$free, -width => 16 );


$slid = $mw->Scale(
           -from => 1,
           -to => 365,
           -orient => "horizontal",
           -variable => \$sdoy,
           -length => 300,
           -width => 7,
           -command => \&fromSDOY
        );

$wdaymen = $mw->Optionmenu(
             -options => [ 
                  ["Monday",1], ["Tuesday",2], ["Wednesday",3], ["Thursday",4], ["Friday",5],
                  ["Saturday",6], ["Sunday",0]
               ],
             -textvariable => \$wdaytext,
             -variable => \$wday
            );
$dow = $mw->Label(
             -textvariable => \$wdaytext
           );


$meeting = "";
$labmeeting = $mw->Label(
             -textvariable => \$meeting,
           );

# Initialise to now
$time = time;
fromTime();

$nowbut = $mw->Button( 
      -text => "Now", 
      -command => sub { $time = time; fromTime(); $slid->bell } );


$clock = "";
$clockbut = $mw->Checkbutton( 
      -text => "Clock", 
      -variable => \$clock,
      -command => sub { if($clock) {$slid->bell} else { $mw->title('Time') } }
      );


$l1 = $mw->Label(
             -text => "Date/Time: "
           );

$daymenu = $mw->Optionmenu(
             -options => [1 .. 31],
             -textvariable => \$day,
             -command => sub { toTime(); }
            );

$monmenu = $mw->Optionmenu(
             -options => [ 
                           ["January",1],  ["February",2],  ["March",3], 
                           ["April",4],  ["May",5],  ["June",6],
                           ["July",7],  ["August",8],  ["September",9],
                           ["October",10], ["November",11], ["December",12]
                         ],
             -textvariable => \$monthtext,
             -variable => \$month,
             -command => sub { toTime(); }
            );

$yeamenu = $mw->Optionmenu(
             -options => [2004 .. 2005],
             -textvariable => \$year,
             -command => sub { toTime(); }
            );

$l2 = $mw->Label(
             -text => "   "
           );

$houmenu = $mw->Optionmenu(
             -options => [0 .. 23],
             -textvariable => \$hour,
             -command => sub { toTime(); }
            );

$l3 = $mw->Label(
             -text => ":"
           );

$minmenu = $mw->Optionmenu(
             -options => [0 .. 59],
             -textvariable => \$minute,
             -command => sub { toTime(); }
            );

$l4 = $mw->Label(
             -text => ":"
           );

$secmenu = $mw->Optionmenu(
             -options => [0 .. 59],
             -textvariable => \$second,
             -command => sub { toTime(); }
            );

$frt = $mw->Button(
             -text => '=',
             -command => sub { fromTime() }
           );

$lookup = $mw->Button(
             -text => '>>>',
             -command => sub { 
=cut
                if(!$time) {
                  $uservar = $lookup->SelectionGet( -selection => "CLIPBOARD" );
                }
=cut
                toTime();
              }
           );


$entry2 = $mw->Entry(
                 -textvariable => \$time, 
                 -width => 10 
           );


$doybox = $mw->Entry(
                 -textvariable => \$doy, 
                 -width => 3 
           );


$lisdst = $mw->Label(
             -textvariable => \$isdst,
           );

$paste = $mw->Button( 
      -text => "Paste", 
      -command => sub { 
         $time = $paste->SelectionGet( -selection => "CLIPBOARD" ); 
         fromTime()
         }
       );

$copy = $mw->Button( 
      -text => "Copy", 
      -command => sub { 
         $copy->clipboardAppend('--',$time); 
         }
       );

$l0 = $mw->Label( -text => "Epoch seconds: " );

       
$l0->grid( $entry2,'-',$frt,$copy,$paste );
$mw->bind('<Button-3>' => \&fromTime);

$l1->grid( $daymenu,$monmenu,$yeamenu, $l2, $houmenu,$l3,$minmenu,$l4,$secmenu );

# $ldow->grid( $dow,'-','-','-','-','-','-','-','-','-');
$ldow = $mw->Label( -text => "Day of week: " );
$ldow->grid($dow);

$lslid = $mw->Label( -text => "Day of year: " );
$lslid->grid( $slid,'-','-','-','-','-','-','-','-','-');

$ldst = $mw->Label( -text => "DST: " );
$ldst->grid($lisdst);

$nowbut->grid($clockbut);

$labmeeting->grid("-");

$mw->repeat(1000, sub { if($clock) { $time = time; fromTime(); $mw->title("$wdaytext, $day $monthtext, $year   $hour:$minute:$second") } });


MainLoop;


print "Back to here\n";


sub toTime {
  $time = timelocal($second,$minute,$hour, $day,$month-1,$year-1900);
  fromTime();
}

sub fromTime {
  ($second,$minute,$hour, $day,$month,$year, $wday,$doy,$isdst) = localtime($time);
  $monthtext = (qw(January February March April May June July August September October November December))[$month];
  $wdaytext = (qw(Sunday Monday Tueday Wednesday Thursday Friday Saturday))[$wday];
  $month++;
  $year += 1900;
  $doy++;
  if($isdst) {
    $isdst = "DST";
  }
  else {
    $isdst = "";
  }

  if($year % 4) {
    $slid->configure(-to => 365);
  }
  else {
    $slid->configure(-to => 366);
  }
  $sdoy = $doy;

  if( ($wday == 1 && $day > 7 && $day < 15) &&
      $month != 1 ) {
    $labmeeting->configure(-foreground => "red");
    $meeting = "Perl Mongers!";
    if($month == 2 && $day == 14) {
      $meeting .= " CHECK";
    }
    unless($time == time) {
      $slid->bell;
    }
  }
  else {
    $labmeeting->configure(-foreground => "black");
    $meeting = "             ";
  }


}
  
sub fromSDOY {
  $time = timelocal(0,0,0, 1,0,$year-1900) + ($sdoy-1) * 24*3600;
  $time += $second + 60 * ($minute + 60*$hour);
  fromTime();
}

